Package org.apache.velocity.runtime.parser.node

# Interface Node

All Superinterfaces:
  `Renderable`

All Known Implementing Classes:
  `ASTAddNode`, `ASTAndNode`, `ASTAssignment`, `ASTBinaryOperator`, `ASTBlock`, `ASTComment`, `ASTComparisonNode`, `ASTDirective`, `ASTDirectiveAssign`, `ASTDivNode`, `ASTElseIfStatement`, `ASTElseStatement`, `ASTEQNode`, `ASTEscape`, `ASTEscapedDirective`, `ASTExpression`, `ASTFalse`, `ASTFloatingPointLiteral`, `ASTGENode`, `ASTGTNode`, `ASTIdentifier`, `ASTIfStatement`, `ASTIncludeStatement`, `ASTIndex`, `ASTIntegerLiteral`, `ASTIntegerRange`, `ASTLENode`, `ASTLogicalOperator`, `ASTLTNode`, `ASTMap`, `ASTMathNode`, `ASTMethod`, `ASTModNode`, `ASTMulNode`, `ASTNegateNode`, `ASTNENode`, `ASTNotNode`, `ASTObjectArray`, `ASTOrNode`, `ASTParameters`, `ASTprocess`, `ASTReference`, `ASTSetDirective`, `ASTStringLiteral`, `ASTSubtractNode`, `ASTText`, `ASTTextblock`, `ASTTrue`, `ASTVariable`, `ASTWord`, `SimpleNode`

public interface Node extends Renderable
This file describes the interface between the Velocity code and the JavaCC generated code.

Version:
  $Id$
Author:
  Henning P. Schmiedehausen

## Method Summary

Modifier and Type
Method
Description
`Object`
`childrenAccept(StandardParserVisitor visitor, Object data)`
`boolean`
`evaluate(InternalContextAdapter context)`
`Object`
`execute(Object o, InternalContextAdapter context)`
`int`
`getColumn()`
`Token`
`getFirstToken()`
`String`
`getFirstTokenImage()`
`int`
`getInfo()`
`Token`
`getLastToken()`
`String`
`getLastTokenImage()`
`int`
`getLine()`
`Parser`
`getParser()`
`Template`
`getTemplate()`
`String`
`getTemplateName()`
`int`
`getType()`
`Object`
`init(InternalContextAdapter context, Object data)`
`boolean`
`isInvalid()`
`Object`
`jjtAccept(StandardParserVisitor visitor, Object data)`
`void`
`jjtAddChild(Node n, int i)`
This method tells the node to add its argument to the node's list of children.
`void`
`jjtClose()`
This method is called after all the child nodes have been added.
`Node`
`jjtGetChild(int i)`
This method returns a child node.
`int`
`jjtGetNumChildren()`
Return the number of children the node has.
`Node`
`jjtGetParent()`
`void`
`jjtOpen()`
This method is called after the node has been made the current node.
`void`
`jjtSetParent(Node n)`
This pair of methods are used to inform the node of its parent.
`String`
`literal()`
`boolean`
`render(InternalContextAdapter context, Writer writer)`
`void`
`setInfo(int info)`
`void`
`setInvalid()`
Mark the node as invalid.
`Object`
`value(InternalContextAdapter context)`

## Method Details

### jjtOpen

void jjtOpen()
This method is called after the node has been made the current node. It indicates that child nodes can now be added to it.

### jjtClose

void jjtClose()
This method is called after all the child nodes have been added.

### jjtSetParent

void jjtSetParent(Node n)
This pair of methods are used to inform the node of its parent.

Parameters:
  `n` -

### jjtGetParent

Node jjtGetParent()

Returns:
  The node parent.

### jjtAddChild

void jjtAddChild(Node n, int i)
This method tells the node to add its argument to the node's list of children.

Parameters:
  `n` -
  `i` -

### jjtGetChild

Node jjtGetChild(int i)
This method returns a child node. The children are numbered from zero, left to right.

Parameters:
  `i` -
Returns:
  A child node.

### jjtGetNumChildren

int jjtGetNumChildren()
Return the number of children the node has.

Returns:
  The number of children of this node.

### jjtAccept

Object jjtAccept(StandardParserVisitor visitor, Object data)

Parameters:
  `visitor` -
  `data` -
Returns:
  The Node execution result object.

### childrenAccept

Object childrenAccept(StandardParserVisitor visitor, Object data)

Parameters:
  `visitor` -
  `data` -
Returns:
  The node execution result.
See Also:
  - `jjtAccept(StandardParserVisitor, Object)`

### getFirstToken

Token getFirstToken()

Returns:
  The first token.

### getLastToken

Token getLastToken()

Returns:
  The last token.

### getType

int getType()

Returns:
  The NodeType.

### init

Object init(InternalContextAdapter context, Object data) throws TemplateInitException

Parameters:
  `context` -
  `data` -
Returns:
  The init result.
Throws:
  `TemplateInitException`

### evaluate

boolean evaluate(InternalContextAdapter context) throws MethodInvocationException

Parameters:
  `context` -
Returns:
  The evaluation result.
Throws:
  `MethodInvocationException`

### value

Object value(InternalContextAdapter context) throws MethodInvocationException

Parameters:
  `context` -
Returns:
  The node value.
Throws:
  `MethodInvocationException`

### render

boolean render(InternalContextAdapter context, Writer writer) throws IOException, MethodInvocationException, ParseErrorException, ResourceNotFoundException

Specified by:
  `render` in interface `Renderable`
Parameters:
  `context` -
  `writer` -
Returns:
  True if the node rendered successfully.
Throws:
  `IOException`
  `MethodInvocationException`
  `ParseErrorException`
  `ResourceNotFoundException`

### execute

Object execute(Object o, InternalContextAdapter context) throws MethodInvocationException

Parameters:
  `o` -
  `context` -
Returns:
  The execution result.
Throws:
  `MethodInvocationException`

### setInfo

void setInfo(int info)

Parameters:
  `info` -

### getInfo

int getInfo()

Returns:
  The current node info.

### literal

String literal()

Returns:
  A literal.

### setInvalid

void setInvalid()
Mark the node as invalid.

### isInvalid

boolean isInvalid()

Returns:
  True if the node is invalid.

### getLine

int getLine()

Returns:
  The current line position.

### getColumn

int getColumn()

Returns:
  The current column position.

### getTemplateName

String getTemplateName()

Returns:
  the file name of the template

### getFirstTokenImage

String getFirstTokenImage()

Returns:
  cached image (String) of the first Token for this Node returned by the Parser

### getLastTokenImage

String getLastTokenImage()

Returns:
  cached image (String) of the last Token for this Node returned by the Parser

### getTemplate

Template getTemplate()

Returns:
  the template this node belongs to

### getParser

Parser getParser()

Returns:
  the parser which generated this node
Since:
  2.2